//+------------------------------------------------------------------+
//|                                                          EMA.mq5 |
//|                                        Copyright 2018, Serj_Che. |
//|                           https://www.mql5.com/ru/users/serj_che |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, Serj_Che."
#property link      "https://www.mql5.com/ru/users/serj_che"
#property version   "1.00"

#include <Trade\Trade.mqh>

input double Lot=0.1;
input int EMA_Period=9;
input ENUM_TIMEFRAMES EMA_Timeframe=PERIOD_H2;
input ENUM_APPLIED_PRICE EMA_Price=PRICE_CLOSE;
input ENUM_APPLIED_PRICE Bar_Price=PRICE_MEDIAN;
input int Bar_Shift=1;

int hema,hprice,sig;
double ema[],barprice[];
CTrade trade;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   hema=iMA(_Symbol,EMA_Timeframe,EMA_Period,0,MODE_EMA,EMA_Price);
   hprice=iMA(_Symbol,EMA_Timeframe,1,0,MODE_SMA,Bar_Price);
   ArraySetAsSeries(ema,true);
   ArraySetAsSeries(barprice,true);
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   if(CopyBuffer(hema,0,0,Bar_Shift+1,ema)<Bar_Shift+1) { Print("ERROR CopyBuffer: ",GetLastError()); return; }
   if(CopyBuffer(hprice,0,0,Bar_Shift+1,barprice)<Bar_Shift+1) { Print("ERROR CopyBuffer: ",GetLastError()); return; }
   sig=0;
   if(barprice[Bar_Shift]>ema[Bar_Shift]) sig=1;
   if(barprice[Bar_Shift]<ema[Bar_Shift]) sig=-1;
   double lot=Lot*sig;
   double poslot=0.0;
   if(PositionSelect(_Symbol))
     {
      poslot=PositionGetDouble(POSITION_VOLUME);
      if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL) poslot*=-1;
     }
   double rlot=lot-poslot;
   double minlot=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
   if(rlot>=minlot) trade.Buy(rlot);
   if(rlot<=-minlot) trade.Sell(-rlot);
  }
//+------------------------------------------------------------------+
  